Index: uspace/lib/c/include/stats.h
===================================================================
--- uspace/lib/c/include/stats.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
+++ uspace/lib/c/include/stats.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -0,0 +1,61 @@
+/*
+ * Copyright (c) 2010 Stanislav Kozina
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_STATS_H_
+#define LIBC_STATS_H_
+
+#include <task.h>
+#include <thread.h>
+#include <stdint.h>
+#include <bool.h>
+#include <kernel/sysinfo/abi.h>
+
+extern stats_cpu_t *stats_get_cpus(size_t *);
+extern stats_physmem_t *stats_get_physmem(void);
+extern load_t *stats_get_load(size_t *);
+extern sysarg_t stats_get_uptime(void);
+
+extern stats_task_t *stats_get_tasks(size_t *);
+extern stats_task_t *stats_get_task(task_id_t);
+
+extern stats_thread_t *stats_get_threads(size_t *);
+extern stats_thread_t *stats_get_thread(thread_id_t);
+
+extern void stats_print_load_fragment(load_t, unsigned int);
+extern const char *thread_get_state(state_t);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/str.h
===================================================================
--- uspace/lib/c/include/str.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/c/include/str.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -86,4 +86,6 @@
 extern char *str_ndup(const char *, size_t max_size);
 
+extern void order_suffix(const uint64_t val, uint64_t *rv, char *suffix);
+
 /*
  * TODO: Get rid of this.
Index: uspace/lib/c/include/str_error.h
===================================================================
--- uspace/lib/c/include/str_error.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
+++ uspace/lib/c/include/str_error.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -0,0 +1,43 @@
+/*
+ * Copyright (c) 2010 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_STRERROR_H_
+#define LIBC_STRERROR_H_
+
+const char *str_error(const int);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/sysinfo.h
===================================================================
--- uspace/lib/c/include/sysinfo.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/c/include/sysinfo.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -31,5 +31,5 @@
  */
 /** @file
- */ 
+ */
 
 #ifndef LIBC_SYSINFO_H_
@@ -37,8 +37,17 @@
 
 #include <libc.h>
-#include <sysinfo.h>
-#include <str.h>
 
-sysarg_t sysinfo_value(const char *name);
+/** Sysinfo value types
+ *
+ */
+typedef enum {
+	SYSINFO_VAL_UNDEFINED = 0,
+	SYSINFO_VAL_VAL = 1,
+	SYSINFO_VAL_DATA = 2
+} sysinfo_item_tag_t;
+
+extern sysinfo_item_tag_t sysinfo_get_tag(const char *);
+extern int sysinfo_get_value(const char *, sysarg_t *);
+extern void *sysinfo_get_data(const char *, size_t *);
 
 #endif
Index: uspace/lib/c/include/task.h
===================================================================
--- uspace/lib/c/include/task.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/c/include/task.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -46,9 +46,8 @@
 
 extern task_id_t task_get_id(void);
-extern int task_set_name(const char *name);
-extern task_id_t task_spawn(const char *path, const char *const argv[]);
-extern int task_wait(task_id_t id, task_exit_t *texit, int *retval);
-extern int task_retval(int val);
-
+extern int task_set_name(const char *);
+extern task_id_t task_spawn(const char *, const char *const[], int *);
+extern int task_wait(task_id_t id, task_exit_t *, int *);
+extern int task_retval(int);
 
 #endif
Index: uspace/lib/clui/Makefile
===================================================================
--- uspace/lib/clui/Makefile	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/clui/Makefile	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -28,4 +28,5 @@
 
 USPACE_PREFIX = ../..
+EXTRA_CFLAGS = -I.
 LIBRARY = libclui
 
Index: uspace/lib/clui/tinput.c
===================================================================
--- uspace/lib/clui/tinput.c	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/clui/tinput.c	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -40,6 +40,5 @@
 #include <assert.h>
 #include <bool.h>
-
-#include "tinput.h"
+#include <tinput.h>
 
 /** Seek direction */
@@ -49,16 +48,16 @@
 } seek_dir_t;
 
-static void tinput_init(tinput_t *ti);
-static void tinput_insert_string(tinput_t *ti, const char *str);
-static void tinput_sel_get_bounds(tinput_t *ti, int *sa, int *sb);
-static bool tinput_sel_active(tinput_t *ti);
-static void tinput_sel_all(tinput_t *ti);
-static void tinput_sel_delete(tinput_t *ti);
-static void tinput_key_ctrl(tinput_t *ti, console_event_t *ev);
-static void tinput_key_shift(tinput_t *ti, console_event_t *ev);
-static void tinput_key_ctrl_shift(tinput_t *ti, console_event_t *ev);
-static void tinput_key_unmod(tinput_t *ti, console_event_t *ev);
-static void tinput_pre_seek(tinput_t *ti, bool shift_held);
-static void tinput_post_seek(tinput_t *ti, bool shift_held);
+static void tinput_init(tinput_t *);
+static void tinput_insert_string(tinput_t *, const char *);
+static void tinput_sel_get_bounds(tinput_t *, size_t *, size_t *);
+static bool tinput_sel_active(tinput_t *);
+static void tinput_sel_all(tinput_t *);
+static void tinput_sel_delete(tinput_t *);
+static void tinput_key_ctrl(tinput_t *, console_event_t *);
+static void tinput_key_shift(tinput_t *, console_event_t *);
+static void tinput_key_ctrl_shift(tinput_t *, console_event_t *);
+static void tinput_key_unmod(tinput_t *, console_event_t *);
+static void tinput_pre_seek(tinput_t *, bool);
+static void tinput_post_seek(tinput_t *, bool);
 
 /** Create a new text input field. */
@@ -66,9 +65,9 @@
 {
 	tinput_t *ti;
-
+	
 	ti = malloc(sizeof(tinput_t));
 	if (ti == NULL)
 		return NULL;
-
+	
 	tinput_init(ti);
 	return ti;
@@ -81,17 +80,17 @@
 }
 
-static void tinput_display_tail(tinput_t *ti, int start, int pad)
-{
-	static wchar_t dbuf[INPUT_MAX_SIZE + 1];
-	int sa, sb;
-	int i, p;
-
+static void tinput_display_tail(tinput_t *ti, size_t start, size_t pad)
+{
+	wchar_t dbuf[INPUT_MAX_SIZE + 1];
+	
+	size_t sa;
+	size_t sb;
 	tinput_sel_get_bounds(ti, &sa, &sb);
-
-	console_goto(fphone(stdout), (ti->col0 + start) % ti->con_cols,
+	
+	console_set_pos(fphone(stdout), (ti->col0 + start) % ti->con_cols,
 	    ti->row0 + (ti->col0 + start) / ti->con_cols);
-	console_set_color(fphone(stdout), COLOR_BLACK, COLOR_WHITE, 0);
-
-	p = start;
+	console_set_style(fphone(stdout), STYLE_NORMAL);
+	
+	size_t p = start;
 	if (p < sa) {
 		memcpy(dbuf, ti->buffer + p, (sa - p) * sizeof(wchar_t));
@@ -100,8 +99,8 @@
 		p = sa;
 	}
-
+	
 	if (p < sb) {
 		fflush(stdout);
-		console_set_color(fphone(stdout), COLOR_BLACK, COLOR_RED, 0);
+		console_set_style(fphone(stdout), STYLE_SELECTED);
 		memcpy(dbuf, ti->buffer + p,
 		    (sb - p) * sizeof(wchar_t));
@@ -110,8 +109,8 @@
 		p = sb;
 	}
-
+	
 	fflush(stdout);
-	console_set_color(fphone(stdout), COLOR_BLACK, COLOR_WHITE, 0);
-
+	console_set_style(fphone(stdout), STYLE_NORMAL);
+	
 	if (p < ti->nc) {
 		memcpy(dbuf, ti->buffer + p,
@@ -120,7 +119,8 @@
 		printf("%ls", dbuf);
 	}
-
-	for (i = 0; i < pad; ++i)
+	
+	for (p = 0; p < pad; p++)
 		putchar(' ');
+	
 	fflush(stdout);
 }
@@ -133,5 +133,5 @@
 static void tinput_position_caret(tinput_t *ti)
 {
-	console_goto(fphone(stdout), (ti->col0 + ti->pos) % ti->con_cols,
+	console_set_pos(fphone(stdout), (ti->col0 + ti->pos) % ti->con_cols,
 	    ti->row0 + (ti->col0 + ti->pos) / ti->con_cols);
 }
@@ -140,33 +140,31 @@
 static void tinput_update_origin(tinput_t *ti)
 {
-	int width, rows;
-
-	width = ti->col0 + ti->nc;
-	rows = (width / ti->con_cols) + 1;
-
+	ipcarg_t width = ti->col0 + ti->nc;
+	ipcarg_t rows = (width / ti->con_cols) + 1;
+	
 	/* Update row0 if the screen scrolled. */
 	if (ti->row0 + rows > ti->con_rows)
-		ti->row0 = ti->con_rows - rows;	
+		ti->row0 = ti->con_rows - rows;
 }
 
 static void tinput_insert_char(tinput_t *ti, wchar_t c)
 {
-	int i;
-	int new_width, new_height;
-
 	if (ti->nc == INPUT_MAX_SIZE)
 		return;
-
-	new_width = ti->col0 + ti->nc + 1;
+	
+	ipcarg_t new_width = ti->col0 + ti->nc + 1;
 	if (new_width % ti->con_cols == 0) {
 		/* Advancing to new line. */
-		new_height = (new_width / ti->con_cols) + 1;
-		if (new_height >= ti->con_rows)
-			return; /* Disallow text longer than 1 page for now. */
-	}
-
-	for (i = ti->nc; i > ti->pos; --i)
+		ipcarg_t new_height = (new_width / ti->con_cols) + 1;
+		if (new_height >= ti->con_rows) {
+			/* Disallow text longer than 1 page for now. */
+			return;
+		}
+	}
+	
+	size_t i;
+	for (i = ti->nc; i > ti->pos; i--)
 		ti->buffer[i] = ti->buffer[i - 1];
-
+	
 	ti->buffer[ti->pos] = c;
 	ti->pos += 1;
@@ -174,5 +172,5 @@
 	ti->buffer[ti->nc] = '\0';
 	ti->sel_start = ti->pos;
-
+	
 	tinput_display_tail(ti, ti->pos - 1, 0);
 	tinput_update_origin(ti);
@@ -182,41 +180,41 @@
 static void tinput_insert_string(tinput_t *ti, const char *str)
 {
-	int i;
-	int new_width, new_height;
-	int ilen;
-	wchar_t c;
-	size_t off;
-
-	ilen = min((ssize_t) str_length(str), INPUT_MAX_SIZE - ti->nc);
+	size_t ilen = min(str_length(str), INPUT_MAX_SIZE - ti->nc);
 	if (ilen == 0)
 		return;
-
-	new_width = ti->col0 + ti->nc + ilen;
-	new_height = (new_width / ti->con_cols) + 1;
-	if (new_height >= ti->con_rows)
-		return; /* Disallow text longer than 1 page for now. */
-
-	for (i = ti->nc - 1; i >= ti->pos; --i)
-		ti->buffer[i + ilen] = ti->buffer[i];
-
-	off = 0; i = 0;
+	
+	ipcarg_t new_width = ti->col0 + ti->nc + ilen;
+	ipcarg_t new_height = (new_width / ti->con_cols) + 1;
+	if (new_height >= ti->con_rows) {
+		/* Disallow text longer than 1 page for now. */
+		return;
+	}
+	
+	if (ti->nc > 0) {
+		size_t i;
+		for (i = ti->nc; i > ti->pos; i--)
+			ti->buffer[i + ilen - 1] = ti->buffer[i - 1];
+	}
+	
+	size_t off = 0;
+	size_t i = 0;
 	while (i < ilen) {
-		c = str_decode(str, &off, STR_NO_LIMIT);
+		wchar_t c = str_decode(str, &off, STR_NO_LIMIT);
 		if (c == '\0')
 			break;
-
+		
 		/* Filter out non-printable chars. */
 		if (c < 32)
 			c = 32;
-
+		
 		ti->buffer[ti->pos + i] = c;
-		++i;
-	}
-
+		i++;
+	}
+	
 	ti->pos += ilen;
 	ti->nc += ilen;
 	ti->buffer[ti->nc] = '\0';
 	ti->sel_start = ti->pos;
-
+	
 	tinput_display_tail(ti, ti->pos - ilen, 0);
 	tinput_update_origin(ti);
@@ -226,21 +224,21 @@
 static void tinput_backspace(tinput_t *ti)
 {
-	int i;
-
 	if (tinput_sel_active(ti)) {
 		tinput_sel_delete(ti);
 		return;
 	}
-
+	
 	if (ti->pos == 0)
 		return;
-
-	for (i = ti->pos; i < ti->nc; ++i)
+	
+	size_t i;
+	for (i = ti->pos; i < ti->nc; i++)
 		ti->buffer[i - 1] = ti->buffer[i];
+	
 	ti->pos -= 1;
 	ti->nc -= 1;
 	ti->buffer[ti->nc] = '\0';
 	ti->sel_start = ti->pos;
-
+	
 	tinput_display_tail(ti, ti->pos, 1);
 	tinput_position_caret(ti);
@@ -253,11 +251,11 @@
 		return;
 	}
-
+	
 	if (ti->pos == ti->nc)
 		return;
-
+	
 	ti->pos += 1;
 	ti->sel_start = ti->pos;
-
+	
 	tinput_backspace(ti);
 }
@@ -266,5 +264,5 @@
 {
 	tinput_pre_seek(ti, shift_held);
-
+	
 	if (dir == seek_forward) {
 		if (ti->pos < ti->nc)
@@ -274,5 +272,5 @@
 			ti->pos -= 1;
 	}
-
+	
 	tinput_post_seek(ti, shift_held);
 }
@@ -281,17 +279,17 @@
 {
 	tinput_pre_seek(ti, shift_held);
-
+	
 	if (dir == seek_forward) {
 		if (ti->pos == ti->nc)
 			return;
-
-		while (1) {
+		
+		while (true) {
 			ti->pos += 1;
-
+			
 			if (ti->pos == ti->nc)
 				break;
-
-			if (ti->buffer[ti->pos - 1] == ' ' &&
-			    ti->buffer[ti->pos] != ' ')
+			
+			if ((ti->buffer[ti->pos - 1] == ' ') &&
+			    (ti->buffer[ti->pos] != ' '))
 				break;
 		}
@@ -299,18 +297,18 @@
 		if (ti->pos == 0)
 			return;
-
-		while (1) {
+		
+		while (true) {
 			ti->pos -= 1;
-
+			
 			if (ti->pos == 0)
 				break;
-
+			
 			if (ti->buffer[ti->pos - 1] == ' ' &&
 			    ti->buffer[ti->pos] != ' ')
 				break;
 		}
-
-	}
-
+	
+	}
+	
 	tinput_post_seek(ti, shift_held);
 }
@@ -319,13 +317,13 @@
 {
 	tinput_pre_seek(ti, shift_held);
-
+	
 	if (dir == seek_forward) {
 		if (ti->pos + ti->con_cols <= ti->nc)
 			ti->pos = ti->pos + ti->con_cols;
 	} else {
-		if (ti->pos - ti->con_cols >= 0)
+		if (ti->pos >= ti->con_cols)
 			ti->pos = ti->pos - ti->con_cols;
 	}
-
+	
 	tinput_post_seek(ti, shift_held);
 }
@@ -334,10 +332,10 @@
 {
 	tinput_pre_seek(ti, shift_held);
-
+	
 	if (dir == seek_backward)
 		ti->pos = 0;
 	else
 		ti->pos = ti->nc;
-
+	
 	tinput_post_seek(ti, shift_held);
 }
@@ -345,5 +343,5 @@
 static void tinput_pre_seek(tinput_t *ti, bool shift_held)
 {
-	if (tinput_sel_active(ti) && !shift_held) {
+	if ((tinput_sel_active(ti)) && (!shift_held)) {
 		/* Unselect and redraw. */
 		ti->sel_start = ti->pos;
@@ -362,4 +360,5 @@
 		ti->sel_start = ti->pos;
 	}
+	
 	tinput_position_caret(ti);
 }
@@ -367,6 +366,4 @@
 static void tinput_history_insert(tinput_t *ti, char *str)
 {
-	int i;
-
 	if (ti->hnum < HISTORY_LEN) {
 		ti->hnum += 1;
@@ -375,10 +372,11 @@
 			free(ti->history[HISTORY_LEN]);
 	}
-
-	for (i = ti->hnum; i > 1; --i)
+	
+	size_t i;
+	for (i = ti->hnum; i > 1; i--)
 		ti->history[i] = ti->history[i - 1];
-
+	
 	ti->history[1] = str_dup(str);
-
+	
 	if (ti->history[0] != NULL) {
 		free(ti->history[0]);
@@ -395,5 +393,5 @@
 }
 
-static void tinput_sel_get_bounds(tinput_t *ti, int *sa, int *sb)
+static void tinput_sel_get_bounds(tinput_t *ti, size_t *sa, size_t *sb)
 {
 	if (ti->sel_start < ti->pos) {
@@ -408,5 +406,5 @@
 static bool tinput_sel_active(tinput_t *ti)
 {
-	return ti->sel_start != ti->pos;
+	return (ti->sel_start != ti->pos);
 }
 
@@ -421,16 +419,18 @@
 static void tinput_sel_delete(tinput_t *ti)
 {
-	int sa, sb;
-
+	size_t sa;
+	size_t sb;
+	
 	tinput_sel_get_bounds(ti, &sa, &sb);
 	if (sa == sb)
 		return;
-
+	
 	memmove(ti->buffer + sa, ti->buffer + sb,
 	    (ti->nc - sb) * sizeof(wchar_t));
+	
 	ti->pos = ti->sel_start = sa;
 	ti->nc -= (sb - sa);
 	ti->buffer[ti->nc] = '\0';
-
+	
 	tinput_display_tail(ti, sa, sb - sa);
 	tinput_position_caret(ti);
@@ -439,9 +439,11 @@
 static void tinput_sel_copy_to_cb(tinput_t *ti)
 {
-	int sa, sb;
+	size_t sa;
+	size_t sb;
+	
+	tinput_sel_get_bounds(ti, &sa, &sb);
+	
 	char *str;
-
-	tinput_sel_get_bounds(ti, &sa, &sb);
-
+	
 	if (sb < ti->nc) {
 		wchar_t tmp_c = ti->buffer[sb];
@@ -454,13 +456,14 @@
 	if (str == NULL)
 		goto error;
-
+	
 	if (clipboard_put_str(str) != EOK)
 		goto error;
-
+	
 	free(str);
 	return;
+	
 error:
+	/* TODO: Give the user some kind of warning. */
 	return;
-	/* TODO: Give the user some warning. */
 }
 
@@ -468,10 +471,11 @@
 {
 	char *str;
-	int rc;
-
-	rc = clipboard_get_str(&str);
-	if (rc != EOK || str == NULL)
-		return; /* TODO: Give the user some warning. */
-
+	int rc = clipboard_get_str(&str);
+	
+	if ((rc != EOK) || (str == NULL)) {
+		/* TODO: Give the user some kind of warning. */
+		return;
+	}
+	
 	tinput_insert_string(ti, str);
 	free(str);
@@ -480,20 +484,24 @@
 static void tinput_history_seek(tinput_t *ti, int offs)
 {
-	int pad;
-
-	if (ti->hpos + offs < 0 || ti->hpos + offs > ti->hnum)
-		return;
-
+	if (offs >= 0) {
+		if (ti->hpos + offs > ti->hnum)
+			return;
+	} else {
+		if (ti->hpos < (size_t) -offs)
+			return;
+	}
+	
 	if (ti->history[ti->hpos] != NULL) {
 		free(ti->history[ti->hpos]);
 		ti->history[ti->hpos] = NULL;
 	}
-
+	
 	ti->history[ti->hpos] = tinput_get_str(ti);
 	ti->hpos += offs;
-
-	pad = ti->nc - str_length(ti->history[ti->hpos]);
-	if (pad < 0) pad = 0;
-
+	
+	int pad = (int) ti->nc - str_length(ti->history[ti->hpos]);
+	if (pad < 0)
+		pad = 0;
+	
 	tinput_set_str(ti, ti->history[ti->hpos]);
 	tinput_display_tail(ti, 0, pad);
@@ -515,55 +523,54 @@
 /** Read in one line of input.
  *
- * @param ti	Text input.
- * @param dstr	Place to save pointer to new string.
- * @return	EOK on success, ENOENT if user requested abort, EIO
- *		if communication with console failed.
+ * @param ti   Text input.
+ * @param dstr Place to save pointer to new string.
+ *
+ * @return EOK on success
+ * @return ENOENT if user requested abort
+ * @return EIO if communication with console failed
+ *
  */
 int tinput_read(tinput_t *ti, char **dstr)
 {
-	console_event_t ev;
-	char *str;
-
 	fflush(stdout);
-
 	if (console_get_size(fphone(stdin), &ti->con_cols, &ti->con_rows) != EOK)
 		return EIO;
+	
 	if (console_get_pos(fphone(stdin), &ti->col0, &ti->row0) != EOK)
 		return EIO;
-
-	ti->pos = ti->sel_start = 0;
+	
+	ti->pos = 0;
+	ti->sel_start = 0;
 	ti->nc = 0;
 	ti->buffer[0] = '\0';
 	ti->done = false;
 	ti->exit_clui = false;
-
+	
 	while (!ti->done) {
 		fflush(stdout);
+		
+		console_event_t ev;
 		if (!console_get_event(fphone(stdin), &ev))
 			return EIO;
-
+		
 		if (ev.type != KEY_PRESS)
 			continue;
-
-		if ((ev.mods & KM_CTRL) != 0 &&
-		    (ev.mods & (KM_ALT | KM_SHIFT)) == 0) {
+		
+		if (((ev.mods & KM_CTRL) != 0) &&
+		    ((ev.mods & (KM_ALT | KM_SHIFT)) == 0))
 			tinput_key_ctrl(ti, &ev);
-		}
-
-		if ((ev.mods & KM_SHIFT) != 0 &&
-		    (ev.mods & (KM_CTRL | KM_ALT)) == 0) {
+		
+		if (((ev.mods & KM_SHIFT) != 0) &&
+		    ((ev.mods & (KM_CTRL | KM_ALT)) == 0))
 			tinput_key_shift(ti, &ev);
-		}
-
-		if ((ev.mods & KM_CTRL) != 0 &&
-		    (ev.mods & KM_SHIFT) != 0 &&
-		    (ev.mods & KM_ALT) == 0) {
+		
+		if (((ev.mods & KM_CTRL) != 0) &&
+		    ((ev.mods & KM_SHIFT) != 0) &&
+		    ((ev.mods & KM_ALT) == 0))
 			tinput_key_ctrl_shift(ti, &ev);
-		}
-
-		if ((ev.mods & (KM_CTRL | KM_ALT | KM_SHIFT)) == 0) {
+		
+		if ((ev.mods & (KM_CTRL | KM_ALT | KM_SHIFT)) == 0)
 			tinput_key_unmod(ti, &ev);
-		}
-
+		
 		if (ev.c >= ' ') {
 			tinput_sel_delete(ti);
@@ -571,18 +578,18 @@
 		}
 	}
-
+	
 	if (ti->exit_clui)
 		return ENOENT;
-
+	
 	ti->pos = ti->nc;
 	tinput_position_caret(ti);
 	putchar('\n');
-
-	str = tinput_get_str(ti);
+	
+	char *str = tinput_get_str(ti);
 	if (str_cmp(str, "") != 0)
 		tinput_history_insert(ti, str);
-
+	
 	ti->hpos = 0;
-
+	
 	*dstr = str;
 	return EOK;
@@ -700,5 +707,5 @@
 		break;
 	case KC_UP:
-		tinput_history_seek(ti, +1);
+		tinput_history_seek(ti, 1);
 		break;
 	case KC_DOWN:
Index: uspace/lib/clui/tinput.h
===================================================================
--- uspace/lib/clui/tinput.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/clui/tinput.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -29,5 +29,5 @@
 /** @addtogroup libclui
  * @{
- */ 
+ */
 /**
  * @file
@@ -37,6 +37,8 @@
 #define LIBCLUI_TINPUT_H_
 
-#define HISTORY_LEN 10
-#define INPUT_MAX_SIZE 1024
+#include <ipc/ipc.h>
+
+#define HISTORY_LEN     10
+#define INPUT_MAX_SIZE  1024
 
 /** Text input field (command line).
@@ -47,23 +49,34 @@
 	/** Buffer holding text currently being edited */
 	wchar_t buffer[INPUT_MAX_SIZE + 1];
+	
 	/** Screen coordinates of the top-left corner of the text field */
-	int col0, row0;
+	ipcarg_t col0;
+	ipcarg_t row0;
+	
 	/** Screen dimensions */
-	int con_cols, con_rows;
+	ipcarg_t con_cols;
+	ipcarg_t con_rows;
+	
 	/** Number of characters in @c buffer */
-	int nc;
+	size_t nc;
+	
 	/** Caret position within buffer */
-	int pos;
+	size_t pos;
+	
 	/** Selection mark position within buffer */
-	int sel_start;
-
+	size_t sel_start;
+	
 	/** History (dynamically allocated strings) */
-	char *history[1 + HISTORY_LEN];
+	char *history[HISTORY_LEN + 1];
+	
 	/** Number of entries in @c history, not counting [0] */
-	int hnum;
+	size_t hnum;
+	
 	/** Current position in history */
-	int hpos;
+	size_t hpos;
+	
 	/** @c true if finished with this line (return to caller) */
 	bool done;
+	
 	/** @c true if user requested to abort interactive loop */
 	bool exit_clui;
@@ -71,6 +84,6 @@
 
 extern tinput_t *tinput_new(void);
-extern void tinput_destroy(tinput_t *ti);
-extern int tinput_read(tinput_t *ti, char **str);
+extern void tinput_destroy(tinput_t *);
+extern int tinput_read(tinput_t *, char **);
 
 #endif
@@ -78,3 +91,2 @@
 /** @}
  */
-
Index: uspace/lib/net/Makefile
===================================================================
--- uspace/lib/net/Makefile	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/net/Makefile	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -37,6 +37,6 @@
 	generic/packet_remote.c \
 	adt/module_map.c \
-	netif/netif.c \
-	netif/netif_standalone.c \
+	netif/netif_local.c \
+	netif/netif_remote.c \
 	netif/netif_nil_bundle.c \
 	nil/nil_remote.c \
Index: uspace/lib/net/adt/module_map.c
===================================================================
--- uspace/lib/net/adt/module_map.c	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/net/adt/module_map.c	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -94,12 +94,13 @@
 }
 
-task_id_t spawn(const char * fname){
-	const char * argv[2];
+task_id_t spawn(const char *fname)
+{
+	const char *argv[2];
 	task_id_t res;
-
+	
 	argv[0] = fname;
 	argv[1] = NULL;
-	res = task_spawn(fname, argv);
-
+	res = task_spawn(fname, argv, NULL);
+	
 	return res;
 }
Index: uspace/lib/net/generic/net_remote.c
===================================================================
--- uspace/lib/net/generic/net_remote.c	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/net/generic/net_remote.c	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -32,5 +32,5 @@
 
 /** @file
- *  Networking interface implementation for standalone remote modules.
+ *  Networking interface implementation for remote modules.
  *  @see net_interface.h
  */
Index: uspace/lib/net/generic/packet_remote.c
===================================================================
--- uspace/lib/net/generic/packet_remote.c	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/net/generic/packet_remote.c	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -32,5 +32,5 @@
 
 /** @file
- *  Packet client interface implementation for standalone remote modules.
+ *  Packet client interface implementation for remote modules.
  *  @see packet_client.h
  */
@@ -47,94 +47,107 @@
 #include <packet/packet_header.h>
 #include <packet/packet_messages.h>
+#include <packet_remote.h>
 
-/** Obtains the packet from the packet server as the shared memory block.
- *  Creates the local packet mapping as well.
- *  @param[in] phone The packet server module phone.
- *  @param[out] packet The packet reference pointer to store the received packet reference.
- *  @param[in] packet_id The packet identifier.
- *  @param[in] size The packet total size in bytes.
- *  @returns EOK on success.
- *  @returns Other error codes as defined for the pm_add() function.
- *  @returns Other error codes as defined for the async_share_in_start() function.
+/** Obtain the packet from the packet server as the shared memory block.
+ *
+ * Create the local packet mapping as well.
+ *
+ * @param[in]  phone     The packet server module phone.
+ * @param[out] packet    The packet reference pointer to store the received
+ *                       packet reference.
+ * @param[in]  packet_id The packet identifier.
+ * @param[in]  size      The packet total size in bytes.
+ *
+ * @return EOK on success.
+ * @return Other error codes as defined for the pm_add() function.
+ * @return Other error codes as defined for the async_share_in_start() function.
+ *
  */
-int packet_return(int phone, packet_ref packet, packet_id_t packet_id, size_t size);
-
-int packet_translate(int phone, packet_ref packet, packet_id_t packet_id){
+static int packet_return(int phone, packet_ref packet, packet_id_t packet_id, size_t size){
 	ERROR_DECLARE;
-
-	ipcarg_t size;
-	packet_t next;
-
-	if(! packet){
-		return EINVAL;
-	}
-	*packet = pm_find(packet_id);
-	if(!(*packet)){
-		ERROR_PROPAGATE(async_req_1_1(phone, NET_PACKET_GET_SIZE, packet_id, &size));
-		ERROR_PROPAGATE(packet_return(phone, packet, packet_id, size));
-	}
-	if((** packet).next){
-		return packet_translate(phone, &next, (** packet).next);
-	}else return EOK;
-}
-
-int packet_return(int phone, packet_ref packet, packet_id_t packet_id, size_t size){
-	ERROR_DECLARE;
-
-	aid_t message;
+	
 	ipc_call_t answer;
-	ipcarg_t result;
-
-	message = async_send_1(phone, NET_PACKET_GET, packet_id, &answer);
+	aid_t message = async_send_1(phone, NET_PACKET_GET, packet_id, &answer);
 	*packet = (packet_t) as_get_mappable_page(size);
-	if(ERROR_OCCURRED(async_share_in_start_0_0(phone, * packet, size))
-		|| ERROR_OCCURRED(pm_add(*packet))){
+	if (ERROR_OCCURRED(async_share_in_start_0_0(phone, *packet, size))
+	    || ERROR_OCCURRED(pm_add(*packet))) {
 		munmap(*packet, size);
 		async_wait_for(message, NULL);
 		return ERROR_CODE;
 	}
+	
+	ipcarg_t result;
 	async_wait_for(message, &result);
+	
 	return result;
 }
 
-packet_t packet_get_4(int phone, size_t max_content, size_t addr_len, size_t max_prefix, size_t max_suffix){
+int packet_translate_remote(int phone, packet_ref packet, packet_id_t packet_id)
+{
 	ERROR_DECLARE;
+	
+	if (!packet)
+		return EINVAL;
+	
+	*packet = pm_find(packet_id);
+	if (!(*packet)) {
+		ipcarg_t size;
+		
+		ERROR_PROPAGATE(async_req_1_1(phone, NET_PACKET_GET_SIZE, packet_id, &size));
+		ERROR_PROPAGATE(packet_return(phone, packet, packet_id, size));
+	}
+	if ((** packet).next) {
+		packet_t next;
+		
+		return packet_translate_remote(phone, &next, (** packet).next);
+	}
+	
+	return EOK;
+}
 
+packet_t packet_get_4_remote(int phone, size_t max_content, size_t addr_len,
+    size_t max_prefix, size_t max_suffix)
+{
+	ERROR_DECLARE;
+	
 	ipcarg_t packet_id;
 	ipcarg_t size;
-	packet_t packet;
-
-	if(ERROR_OCCURRED(async_req_4_2(phone, NET_PACKET_CREATE_4, max_content, addr_len, max_prefix, max_suffix, &packet_id, &size))){
+	
+	if (ERROR_OCCURRED(async_req_4_2(phone, NET_PACKET_CREATE_4, max_content,
+	    addr_len, max_prefix, max_suffix, &packet_id, &size)))
 		return NULL;
+	
+	
+	packet_t packet = pm_find(packet_id);
+	if (!packet) {
+		if (ERROR_OCCURRED(packet_return(phone, &packet, packet_id, size)))
+			return NULL;
 	}
-	packet = pm_find(packet_id);
-	if(! packet){
-		if(ERROR_OCCURRED(packet_return(phone, &packet, packet_id, size))){
-			return NULL;
-		}
-	}
+	
 	return packet;
 }
 
-packet_t packet_get_1(int phone, size_t content){
+packet_t packet_get_1_remote(int phone, size_t content)
+{
 	ERROR_DECLARE;
-
+	
 	ipcarg_t packet_id;
 	ipcarg_t size;
-	packet_t packet;
-
-	if(ERROR_OCCURRED(async_req_1_2(phone, NET_PACKET_CREATE_1, content, &packet_id, &size))){
+	
+	if (ERROR_OCCURRED(async_req_1_2(phone, NET_PACKET_CREATE_1, content,
+	    &packet_id, &size)))
 		return NULL;
+	
+	packet_t packet = pm_find(packet_id);
+	if (!packet) {
+		if (ERROR_OCCURRED(packet_return(phone, &packet, packet_id, size)))
+			return NULL;
 	}
-	packet = pm_find(packet_id);
-	if(! packet){
-		if(ERROR_OCCURRED(packet_return(phone, &packet, packet_id, size))){
-			return NULL;
-		}
-	}
+	
 	return packet;
 }
 
-void pq_release(int phone, packet_id_t packet_id){
+void pq_release_remote(int phone, packet_id_t packet_id)
+{
 	async_msg_1(phone, NET_PACKET_RELEASE, packet_id);
 }
Index: uspace/lib/net/il/arp_remote.c
===================================================================
--- uspace/lib/net/il/arp_remote.c	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/net/il/arp_remote.c	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -32,5 +32,5 @@
 
 /** @file
- *  ARP interface implementation for standalone remote modules.
+ *  ARP interface implementation for remote modules.
  *  @see arp_interface.h
  */
Index: uspace/lib/net/il/ip_client.c
===================================================================
--- uspace/lib/net/il/ip_client.c	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/net/il/ip_client.c	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -56,5 +56,5 @@
 }
 
-int ip_client_get_pseudo_header(ip_protocol_t protocol, struct sockaddr * src, socklen_t srclen, struct sockaddr * dest, socklen_t destlen, size_t data_length, ip_pseudo_header_ref * header, size_t * headerlen){
+int ip_client_get_pseudo_header(ip_protocol_t protocol, struct sockaddr * src, socklen_t srclen, struct sockaddr * dest, socklen_t destlen, size_t data_length, void **header, size_t * headerlen){
 	ipv4_pseudo_header_ref header_in;
 	struct sockaddr_in * address_in;
@@ -84,5 +84,5 @@
 			header_in->protocol = protocol;
 			header_in->data_length = htons(data_length);
-			*header = (ip_pseudo_header_ref) header_in;
+			*header = header_in;
 			return EOK;
 		// TODO IPv6
@@ -164,5 +164,5 @@
 }
 
-int ip_client_set_pseudo_header_data_length(ip_pseudo_header_ref header, size_t headerlen, size_t data_length){
+int ip_client_set_pseudo_header_data_length(void *header, size_t headerlen, size_t data_length){
 	ipv4_pseudo_header_ref header_in;
 
